#include <iostream>
#include "Mapping Core/MappingCore.h"
#include <fstream>
using namespace std;

int main()
{
	MapFile map;
	const char* filename = nullptr;

	if ( map.LoadFile(filename) )
	{
		char outFileName[MAX_PATH];
			sprintf_s(outFileName, MAX_PATH, "%s - Locations.txt", strrchr(filename, '\\')+1);
			ofstream outFile(outFileName);

		cout << "Loaded File: " << strrchr(filename, '\\')+1 << endl;
		outFile << "Map Version: " << map.VER().get<u16>(0) << endl;

		if ( map.MRGN().exists() )
		{
			cout << "Locations Identified" << endl;
			outFile << "MRGN Size: " << map.MRGN().size() << endl;
			cout << "Dumping Location To: " << outFileName << endl;

			ChkLocation* loc;
			for ( u32 i=0; i<map.MRGN().size()/CHK_LOCATION_SIZE; i++ )
			{
				string locName;
				if ( map.getLocation(loc, i) )
				{
					if ( loc->stringNum == 0 || !map.getString(locName, loc->stringNum) )
						locName = "<NO NAME>";
					outFile << "Location #" << i << " \"" << locName.c_str() << "\" ("
							<< loc->xc1 << ", " << loc->yc1 << ") to ("
							<< loc->xc2 << ", " << loc->yc2 << "), Elevation: "
							<< loc->elevation << endl;
				}
			}

			outFile.close();
			cout << "Finished!" << endl;
		}
		else
			cout << "Map does not contain locations!" << endl;
	}
	else
		cout << "Failed to load scenario file" << endl;

	while ( true )
		cin.get();

	return 0;
}
